#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: legolas1989@qq.com
# +-------------------------------------------------------------------


import sys, os, json

# 设置运行目录
os.chdir("/www/server/panel")

# 添加包引用位置并引用公共包
sys.path.append("class/")
import public

# from common import dict_obj
# get = dict_obj();


# 在非命令行模式下引用面板缓存和session对象
if __name__ != '__main__':
    from BTPanel import cache, session, redirect

    # 设置缓存(超时10秒) cache.set('key',value,10)
    # 获取缓存 cache.get('key')
    # 删除缓存 cache.delete('key')

    # 设置session:  session['key'] = value
    # 获取session:  value = session['key']
    # 删除session:  del(session['key'])


class ip_list_main:
    __plugin_path = "/www/server/panel/plugin/ip_list/"
    __config = None

    file_black_path = "/www/server/nginx/conf/"
    file = "blackip.conf"

    # 构造方法
    def __init__(self):
        pass

    # 访问/ip_list/index.html时调用的方法，需要在templates中有index.html，否则无法正确响应模板
    def index(self, args):
        return self.get_logs(args)

    def get_ip_list(self, args):
        vhost_path = "/www/server/panel/vhost/nginx/"
        nginx_file_pah = "/www/server/nginx/conf/nginx.conf"

        file_black = self.file_black_path + self.file
        if os.path.exists(file_black) is False:
            os.mknod(file_black)
            # 修改nginx配置文件加载该文件
            if os.path.exists(nginx_file_pah) is True:
                # 加载命令
                not_n_str = "include blackip.conf;"
                include_str = "\n include blackip.conf; \n"
                f_body = public.ReadFile(nginx_file_pah, mode='r')
                if f_body.find(not_n_str) < 0:
                    replace_str = "include /www/server/panel/vhost/nginx/*.conf"
                    new_body = f_body.replace(replace_str, include_str + replace_str, 1)
                    public.WriteFile(nginx_file_pah, new_body, mode='w+')

            pass

        ip_body = public.ReadFile(file_black, mode='r')
        return {'data': ip_body}

    def put_ip_list(self, args):
        file_black = self.file_black_path + self.file

        result = public.WriteFile(file_black, args.data, mode='w+')

        web_server = public.GetWebServer()
        if web_server == 'nginx':
            nginx_reload_command = "nginx -s reload"
            public.ServiceReload()

        rdata = {}
        if result:
            rdata['code'] = 0
            rdata['message'] = '修改成功'
        else:
            rdata['code'] = -1
            rdata['message'] = '修改失败'
        return rdata

    # 读取配置项(插件自身的配置文件)
    # @param key 取指定配置项，若不传则取所有配置[可选]
    # @param force 强制从文件重新读取配置项[可选]
    def __get_config(self, key=None, force=False):
        # 判断是否从文件读取配置
        if not self.__config or force:
            config_file = self.__plugin_path + 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)

        # 取指定配置项
        if key:
            if key in self.__config: return self.__config[key]
            return None
        return self.__config

    # 设置配置项(插件自身的配置文件)
    # @param key 要被修改或添加的配置项[可选]
    # @param value 配置值[可选]
    def __set_config(self, key=None, value=None):
        # 是否需要初始化配置项
        if not self.__config: self.__config = {}

        # 是否需要设置配置值
        if key:
            self.__config[key] = value

        # 写入到配置文件
        config_file = self.__plugin_path + 'config.json'
        public.WriteFile(config_file, json.dumps(self.__config))
        return True
